<?php 

App::uses('PayanywayController', 'Payment.Controller');

class PayanywayAlfaclickController extends PayanywayController {
	var $uses = array('PaymentMethod', 'Order');
	var $module_name = 'PayanywayAlfaclick';
	var $icon = 'alfaclick.png';
	var $params = array('unit_id' => 587412, 'account_id' => 0, 'online' => 1);

	function settings ()
	{
		$parent = new PayanywayController();
		$this->set('data', $this->PaymentMethod->findByAlias($parent->module_name));
	}

	function install()
	{
		$new_module = array();
		$new_module['PaymentMethod']['active'] = '1';
		$new_module['PaymentMethod']['default'] = '0';
		$new_module['PaymentMethod']['name'] = Inflector::humanize($this->module_name);
		$new_module['PaymentMethod']['icon'] = $this->icon;
		$new_module['PaymentMethod']['alias'] = $this->module_name;

		$this->PaymentMethod->saveAll($new_module);

		$this->Session->setFlash(__('Module Installed'));
		$this->redirect('/payment_methods/admin/');
	}

	function before_process () 
	{
		$this->additionalParameters = "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_alfaIdClient'>".__d("payanyway","Internet-bank login")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_alfaIdClient' name='additionalParameters.alfaIdClient' value='' /></div>";
		$this->additionalParameters .= "</div>";
		$this->additionalParameters .= "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_alfaPaymentPurpose'>".__d("payanyway","Payment purpose")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_alfaPaymentPurpose' name='additionalParameters.alfaPaymentPurpose' value='' /></div>";
		$this->additionalParameters .= "</div>";
		
		$this->validationJS = <<<HTML
<script type="text/javascript" src="{base_path}/js/modified.js"></script>
<script type="text/javascript" src="{base_path}/js/focus-first-input.js"></script>
<script type="text/javascript" src="{base_path}/js/jquery/plugins/validate/jquery.validate.pack.js"></script>
<script type='text/javascript'>
	$(document).ready(function() {
		$("#contentform").validate({
			rules: {
				'additionalParameters.alfaIdClient': { required: true }
			},
			messages: {
				'additionalParameters.alfaIdClient': { required: "{lang}Required field{/lang}" }
			}
		});
	});
</script>
HTML;
		return parent::before_process();
	}
	
}

?>