<?php 

App::uses('PaymentAppController', 'Payment.Controller');

class PayanywayController extends PaymentAppController {
	
	var $uses = array('PaymentMethod', 'Order');
	var $module_name = 'Payanyway';
	var $icon = 'payanyway.png';
	var $params = array('unit_id' => 0, 'account_id' => 0, 'online' => 1);
	var $additionalParameters = "";
	var $validationJS = "";
	
	function settings ()
	{
		$this->set('data', $this->PaymentMethod->findByAlias($this->module_name));
	}

	function install()
	{
		$new_module = array();
		$new_module['PaymentMethod']['active'] = '1';
		$new_module['PaymentMethod']['default'] = '0';
		$new_module['PaymentMethod']['name'] = Inflector::humanize($this->module_name);
		$new_module['PaymentMethod']['icon'] = $this->icon;
		$new_module['PaymentMethod']['alias'] = $this->module_name;

		$new_module['PaymentMethodValue'][0]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][0]['key'] = 'payment_url';
		$new_module['PaymentMethodValue'][0]['value'] = 'www.payanyway.ru';

		$new_module['PaymentMethodValue'][1]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][1]['key'] = 'mnt_id';
		$new_module['PaymentMethodValue'][1]['value'] = '';

		$new_module['PaymentMethodValue'][2]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][2]['key'] = 'mnt_dataintegrity_code';
		$new_module['PaymentMethodValue'][2]['value'] = '';

		$new_module['PaymentMethodValue'][3]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][3]['key'] = 'mnt_test_mode';
		$new_module['PaymentMethodValue'][3]['value'] = '0';

		$new_module['PaymentMethodValue'][4]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][4]['key'] = 'mnt_currency';
		$new_module['PaymentMethodValue'][4]['value'] = '';

		$new_module['PaymentMethodValue'][5]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][5]['key'] = 'payanyway_login';
		$new_module['PaymentMethodValue'][5]['value'] = '';

		$new_module['PaymentMethodValue'][6]['payment_method_id'] = $this->PaymentMethod->id;
		$new_module['PaymentMethodValue'][6]['key'] = 'payanyway_password';
		$new_module['PaymentMethodValue'][6]['value'] = '';

		$this->PaymentMethod->saveAll($new_module);

		$this->Session->setFlash(__('Module Installed'));
		$this->redirect('/payment_methods/admin/');
	}

	function uninstall()
	{

		$module_id = $this->PaymentMethod->findByAlias($this->module_name);

		$this->PaymentMethod->delete($module_id['PaymentMethod']['id'], true);
			
		$this->Session->setFlash(__('Module Uninstalled'));
		$this->redirect('/payment_methods/admin/');
	}

	function before_process () 
	{
		global $currency, $config;
		
		$order = $this->Order->read(null,$_SESSION['Customer']['order_id']);
		
		$payment_method = $this->PaymentMethod->find('first', array('conditions' => array('alias' => $this->module_name)));

		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'payment_url')));
		$payment_url = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'mnt_id')));
		$mnt_id = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'mnt_dataintegrity_code')));
		$mnt_dataintegrity_code = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'mnt_test_mode')));
		$mnt_test_mode = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'mnt_currency')));
		$mnt_currency = $settings['PaymentMethodValue']['value'];
		$mnt_amount = number_format($order['Order']['total'],2,'.','');
		
		$success_url = 'http://'.$_SERVER['HTTP_HOST'] .  BASE . '/orders/place_order/';
		$fail_url = 'http://'.$_SERVER['HTTP_HOST'] .  BASE . '/page/checkout' . $config['URL_EXTENSION'];
		
		$action = ($this->params['online']) ? 'https://'.$payment_url.'/assistant.htm' : 'http://'.$_SERVER['HTTP_HOST'] . '/orders/place_order/';
		
		$content = $this->validationJS;
		$content .= '<form id="contentform" action="'.$action.'" method="post">
			<input type="hidden" name="MNT_ID" value="'.$mnt_id.'">
			<input type="hidden" name="MNT_TRANSACTION_ID" value="' . $_SESSION['Customer']['order_id'] . '">
			<input type="hidden" name="MNT_AMOUNT" value="' . $mnt_amount . '">
			<input type="hidden" name="MNT_CURRENCY_CODE" value="' . $mnt_currency . '">
			<input type="hidden" name="MNT_TEST_MODE" value="' . $mnt_test_mode . '">
			<input type="hidden" name="MNT_SUCCESS_URL" value="' . $success_url . '">
			<input type="hidden" name="MNT_FAIL_URL" value="' . $fail_url . '">
			<input type="hidden" name="MNT_SIGNATURE" value="'.md5($mnt_id.$_SESSION['Customer']['order_id'].$mnt_amount.$mnt_currency.$mnt_test_mode.$mnt_dataintegrity_code).'">
			<input type="hidden" name="payment_system" value="' . $this->module_name . '">
			<input type="hidden" name="online" value="' . $this->params['online'] . '">
				';
		if ($this->params['unit_id'])
			$content .= '<input type="hidden" name="paymentSystem.unitId" value="'.$this->params['unit_id'].'">';
		if ($this->params['account_id'])
			$content .= '<input type="hidden" name="paymentSystem.accountId" value="'.$this->params['account_id'].'">';
		if ($this->module_name !== 'PayanywayController'){
			$content .= '<input type="hidden" name="followup" value="true">';
			$content .= '<input type="hidden" name="javascriptEnabled" value="true">';
		}
		if (!empty($this->additionalParameters)) {
			$content .= "<div id='additional_information' class='form-horizontal'>";
			$content .= "<div><h3>".__d("payanyway","Additional information")."</h3></div>";
			$content .= $this->additionalParameters;
			$content .= "</div>";
		}
						
		$content .= '
			<button class="btn btn-inverse" type="submit" value="{lang}Process to Payment{/lang}"><i class="icon-ok"></i> {lang}Process to Payment{/lang}</button>
			</form>';
	
		return $content;
	}

	function after_process()
	{
		global $config;
		
		/* if is invoice request */
		if (!intval($_POST['online'])) {
			
			$this->invoice();
			
			$this->redirect('/page/success'.$config['URL_EXTENSION']);
		}
	}
	
	function invoice(){
		require_once (dirname(__FILE__) . '/MonetaAPI/MonetaWebService.php');
		
		$payment_system = $_REQUEST['payment_system'];
		
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'payment_url')));
		$payment_url = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'payanyway_login')));
		$payanyway_login = $settings['PaymentMethodValue']['value'];
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'payanyway_password')));
		$payanyway_password = $settings['PaymentMethodValue']['value'];
		
		if ($payment_url == 'www.payanyway.ru') {
			$service = new MonetaWebService("https://www.payanyway.ru/services.wsdl", $payanyway_login, $payanyway_password);
		} else {
			$service = new MonetaWebService("https://demo.moneta.ru/services.wsdl", $payanyway_login, $payanyway_password);
		}
		
		try {
			$totalAmount = $_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'];
			$fee = "-";
			
			if (isset($_REQUEST['paymentSystem_accountId'])) {
				$transactionRequestType = new MonetaForecastTransactionRequest();
				$transactionRequestType->payer = $_REQUEST['paymentSystem_accountId'];
				$transactionRequestType->payee = $_REQUEST['MNT_ID'];
				$transactionRequestType->amount = $_REQUEST['MNT_AMOUNT'];
				$transactionRequestType->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];
				$forecast = $service->ForecastTransaction($transactionRequestType);
				$totalAmount = number_format($forecast->payerAmount,2,'.','')." ".$forecast->payerCurrency;
				$fee = number_format($forecast->payerFee,2,'.','')." ".$forecast->payerCurrency;
			}
			
			// получить данные счета
			$request = new MonetaInvoiceRequest();
			if (isset($_REQUEST['paymentSystem_accountId']))
				$request->payer = $_REQUEST['paymentSystem_accountId'];
			$request->payee = $_REQUEST['MNT_ID'];
			$request->amount = $_REQUEST['MNT_AMOUNT'];
			$request->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];

			if ($payment_system == 'PayanywayPostController') {
				$operationInfo = new MonetaOperationInfo();
				$a = new MonetaKeyValueAttribute();
				$a->key = 'mailofrussiaindex';
				$a->value = $_REQUEST['additionalParameters_mailofrussiaSenderIndex'];
				$operationInfo->addAttribute($a);
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'mailofrussiaregion';
				$a1->value = $_REQUEST['additionalParameters_mailofrussiaSenderRegion'];
				$operationInfo->addAttribute($a1);
				$a2 = new MonetaKeyValueAttribute();
				$a2->key = 'mailofrussiaaddress';
				$a2->value = $_REQUEST['additionalParameters_mailofrussiaSenderAddress'];
				$operationInfo->addAttribute($a2);
				$a3 = new MonetaKeyValueAttribute();
				$a3->key = 'mailofrussianame';
				$a3->value = $_REQUEST['additionalParameters_mailofrussiaSenderName'];
				$operationInfo->addAttribute($a3);
				$request->operationInfo = $operationInfo;
			}
			elseif ($payment_system == 'PayanywayEurosetController')
			{
				$operationInfo = new MonetaOperationInfo();
				$a1 = new MonetaKeyValueAttribute();
				$a1->key = 'rapidamphone';
				$a1->value = $_REQUEST['additionalParameters_rapidaPhone'];
				$operationInfo->addAttribute($a1);
				$request->operationInfo = $operationInfo;
			}
			$response = $service->Invoice($request);
			if ($payment_system == 'euroset')
			{
				$response1 = $service->GetOperationDetailsById($response->transaction);
				foreach ($response1->operation->attribute as $attr)
				{
					if ($attr->key == 'rapidatid')
					{
						$transaction_id = $attr->value;
					}
				}
			}
			else
			{
				$transaction_id = $response->transaction;
			}

			$_SESSION["Payanyway_invoice"]["payment_system"] = $_POST["payment_system"];
			$_SESSION["Payanyway_invoice"]["payment_url"] = $payment_url;
			$_SESSION["Payanyway_invoice"]["status"] = $response->status;
			$_SESSION["Payanyway_invoice"]["transaction"] = str_pad($transaction_id, 10, "0", STR_PAD_LEFT);
			$_SESSION["Payanyway_invoice"]["amount"] = $_POST['MNT_AMOUNT']." ".$_POST['MNT_CURRENCY_CODE'];
			$_SESSION["Payanyway_invoice"]["fee"] = $fee;
			$_SESSION["Payanyway_invoice"]["total_amount"] = $totalAmount;
			$_SESSION["Payanyway_invoice"]["unitid"] = $_POST["paymentSystem_unitId"];
			
			/* Empty the cart */
			$_SESSION['Customer']['order_id'] = null;
		}
		catch (Exception $e) {
			$_SESSION["Payanyway_invoice"]["payment_system"] = $_POST["payment_system"];
			$_SESSION["Payanyway_invoice"]["status"] = 'FAILED';
			$_SESSION["Payanyway_invoice"]["error"] = $e->getMessage();
		}
		
		return;
	}
	
	function result()
	{
		$settings = $this->PaymentMethod->PaymentMethodValue->find('first', array('conditions' => array('key' => 'mnt_dataintegrity_code')));
		$mnt_dataintegrity_code = $settings['PaymentMethodValue']['value'];
		
		if (isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID'])
			&& isset($_REQUEST['MNT_AMOUNT']) && isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE'])
			&& isset($_REQUEST['MNT_SIGNATURE']) )
		{
			if ($_REQUEST['MNT_SIGNATURE'] == md5($_REQUEST['MNT_ID'] . stripslashes($_REQUEST['MNT_TRANSACTION_ID']) . $_REQUEST['MNT_OPERATION_ID'] . $_REQUEST['MNT_AMOUNT'] . $_REQUEST['MNT_CURRENCY_CODE'] . $_REQUEST['MNT_TEST_MODE'] . $mnt_dataintegrity_code)) {
				$order = $this->Order->read(null,$_REQUEST['MNT_TRANSACTION_ID']);
				if ($order) {
					$payment_method = $this->PaymentMethod->find('first', array('conditions' => array('alias' => $this->module_name)));
					$order_data = $this->Order->find('first', array('conditions' => array('Order.id' => $_POST['MNT_TRANSACTION_ID'])));
					$order_data['Order']['order_status_id'] = $payment_method['PaymentMethod']['order_status_id'];
					$this->Order->save($order_data);
					die("SUCCESS");
				} else die("FAIL");
			} else die("FAIL");
		} else die("FAIL");
		
	}
	
}

?>