<?php 

App::uses('PayanywayController', 'Payment.Controller');

class PayanywayEurosetController extends PayanywayController {
	var $uses = array('PaymentMethod', 'Order');
	var $module_name = 'PayanywayEuroset';
	var $icon = 'euroset.png';
	var $params = array('unit_id' => 248362, 'account_id' => 136, 'online' => 0);

	function settings ()
	{
		$parent = new PayanywayController();
		$this->set('data', $this->PaymentMethod->findByAlias($parent->module_name));
	}

	function install()
	{
		$new_module = array();
		$new_module['PaymentMethod']['active'] = '1';
		$new_module['PaymentMethod']['default'] = '0';
		$new_module['PaymentMethod']['name'] = Inflector::humanize($this->module_name);
		$new_module['PaymentMethod']['icon'] = $this->icon;
		$new_module['PaymentMethod']['alias'] = $this->module_name;

		$this->PaymentMethod->saveAll($new_module);

		$this->Session->setFlash(__('Module Installed'));
		$this->redirect('/payment_methods/admin/');
	}

	function before_process () 
	{
		$this->additionalParameters = "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_rapidaPhone'>".__d("payanyway","Phone number")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_rapidaPhone' name='additionalParameters.rapidaPhone' value='' /></div>";
		$this->additionalParameters .= "</div>";
		
		$rapidaPhone_error = __d("payanyway", "Phone number in international format. For example +71234567890");
		$this->validationJS = <<<HTML
<script type="text/javascript" src="{base_path}/js/modified.js"></script>
<script type="text/javascript" src="{base_path}/js/focus-first-input.js"></script>
<script type="text/javascript" src="{base_path}/js/jquery/plugins/validate/jquery.validate.pack.js"></script>
<script type='text/javascript'>
{literal}
jQuery.validator.addMethod("rapidaPhone", function(phone_number, element) {
	return this.optional(element) || phone_number.length > 10 && phone_number.match(/^(\+)(\d|\s|\(|\)){10,20}$/);
}, "{$rapidaPhone_error}");
{/literal}
	$(document).ready(function() {
		$("#contentform").validate({
			rules: {
				'additionalParameters.rapidaPhone': { required: true, rapidaPhone: true }
			},
			messages: {
				'additionalParameters.rapidaPhone': { required: "{lang}Required field{/lang}" }
			}
		});
	});
</script>
HTML;
		
		return parent::before_process();
	}
}

?>