<?php 

App::uses('PayanywayController', 'Payment.Controller');

class PayanywayPostController extends PayanywayController {
	var $uses = array('PaymentMethod', 'Order');
	var $module_name = 'PayanywayPost';
	var $icon = 'post.png';
	var $params = array('unit_id' => 1029, 'account_id' => 15, 'online' => 0);

	function settings ()
	{
		$parent = new PayanywayController();
		$this->set('data', $this->PaymentMethod->findByAlias($parent->module_name));
	}

	function install()
	{
		$new_module = array();
		$new_module['PaymentMethod']['active'] = '1';
		$new_module['PaymentMethod']['default'] = '0';
		$new_module['PaymentMethod']['name'] = Inflector::humanize($this->module_name);
		$new_module['PaymentMethod']['icon'] = $this->icon;
		$new_module['PaymentMethod']['alias'] = $this->module_name;

		$this->PaymentMethod->saveAll($new_module);

		$this->Session->setFlash(__('Module Installed'));
		$this->redirect('/payment_methods/admin/');
	}

	function before_process () 
	{
		$this->additionalParameters = "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_mailofrussiaSenderIndex'>".__d("payanyway","Sender Index")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_mailofrussiaSenderIndex' name='additionalParameters.mailofrussiaSenderIndex' value='' /></div>";
		$this->additionalParameters .= "</div>";
		$this->additionalParameters .= "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_mailofrussiaSenderRegion'>".__d("payanyway","Sender Region")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_mailofrussiaSenderRegion' name='additionalParameters.mailofrussiaSenderRegion' value='' /></div>";
		$this->additionalParameters .= "</div>";
		$this->additionalParameters .= "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_mailofrussiaSenderAddress'>".__d("payanyway","Sender Address")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_mailofrussiaSenderAddress' name='additionalParameters.mailofrussiaSenderAddress' value='' /></div>";
		$this->additionalParameters .= "</div>";
		$this->additionalParameters .= "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_mailofrussiaSenderName'>".__d("payanyway","Sender Name")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_mailofrussiaSenderName' name='additionalParameters.mailofrussiaSenderName' value='' /></div>";
		$this->additionalParameters .= "</div>";
		
		$this->validationJS = <<<HTML
<script type="text/javascript" src="{base_path}/js/modified.js"></script>
<script type="text/javascript" src="{base_path}/js/focus-first-input.js"></script>
<script type="text/javascript" src="{base_path}/js/jquery/plugins/validate/jquery.validate.pack.js"></script>
<script type='text/javascript'>
	$(document).ready(function() {
		$("#contentform").validate({
			rules: {
				'additionalParameters.mailofrussiaSenderIndex': { required: true },
				'additionalParameters.mailofrussiaSenderRegion': { required: true },
				'additionalParameters.mailofrussiaSenderAddress': { required: true },
				'additionalParameters.mailofrussiaSenderName': { required: true }
			},
			messages: {
				'additionalParameters.mailofrussiaSenderIndex': { required: "{lang}Required field{/lang}" },
				'additionalParameters.mailofrussiaSenderRegion': { required: "{lang}Required field{/lang}" },
				'additionalParameters.mailofrussiaSenderAddress': { required: "{lang}Required field{/lang}" },
				'additionalParameters.mailofrussiaSenderName': { required: "{lang}Required field{/lang}" }
			}
		});
	});
</script>
HTML;

		return parent::before_process();
	}

}

?>