<?php 

App::uses('PayanywayController', 'Payment.Controller');

class PayanywayQiwiController extends PayanywayController {
	var $uses = array('PaymentMethod', 'Order');
	var $module_name = 'PayanywayQiwi';
	var $icon = 'qiwi.png';
	var $params = array('unit_id' => 822360, 'account_id' => 0, 'online' => 1);

	function settings ()
	{
		$parent = new PayanywayController();
		$this->set('data', $this->PaymentMethod->findByAlias($parent->module_name));
	}

	function install()
	{
		$new_module = array();
		$new_module['PaymentMethod']['active'] = '1';
		$new_module['PaymentMethod']['default'] = '0';
		$new_module['PaymentMethod']['name'] = Inflector::humanize($this->module_name);
		$new_module['PaymentMethod']['icon'] = $this->icon;
		$new_module['PaymentMethod']['alias'] = $this->module_name;

		$this->PaymentMethod->saveAll($new_module);

		$this->Session->setFlash(__('Module Installed'));
		$this->redirect('/payment_methods/admin/');
	}

	function before_process () 
	{
		$this->additionalParameters = "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_qiwiUser'>".__d("payanyway","Phone number")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_qiwiUser' name='additionalParameters.qiwiUser' value='' /></div>";
		$this->additionalParameters .= "</div>";
		$this->additionalParameters .= "<div class='control-group'>";
		$this->additionalParameters .= "<label class='control-label' for='additionalParameters_qiwiComment'>".__d("payanyway","Comment")."</label>";
		$this->additionalParameters .= "<div class='controls'><input type='text' id='additionalParameters_qiwiComment' name='additionalParameters.qiwiComment' value='' /></div>";
		$this->additionalParameters .= "</div>";
		
		$qiwiUser_error = __d("payanyway", "Phone number formatted as 10 digits, w/o +7 or 8.");
		$this->validationJS = <<<HTML
<script type="text/javascript" src="{base_path}/js/modified.js"></script>
<script type="text/javascript" src="{base_path}/js/focus-first-input.js"></script>
<script type="text/javascript" src="{base_path}/js/jquery/plugins/validate/jquery.validate.pack.js"></script>
<script type='text/javascript'>
{literal}
jQuery.validator.addMethod("qiwiUser", function(phone_number, element) {
	return this.optional(element) || phone_number.match(/^[\d]{10}$/);
}, "{$qiwiUser_error}");
{/literal}
	$(document).ready(function() {
		$("#contentform").validate({
			rules: {
				'additionalParameters.qiwiUser': { required: true, qiwiUser: true }
			},
			messages: {
				'additionalParameters.qiwiUser': { required: "{lang}Required field{/lang}" }
			}
		});
	});
</script>
HTML;
		return parent::before_process();
	}
}

?>